<?php

##################################################################################
#    PHP-RESIDENCE
#    Copyright (C) 2001-2008 by Marco Maria Francesco De Santis (marco@digitaldruid.net)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    any later version accepted by Marco Maria Francesco De Santis, which
#    shall act as a proxy as defined in Section 14 of version 3 of the
#    license.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##################################################################################



function cancella_nazione ($num_nazione,$id_utente_mod,$tablenazioni,$tablerelutenti) {
esegui_query("delete from $tablerelutenti where idutente = '$id_utente_mod' and idnazione = '$num_nazione'");
$nazione_usata = esegui_query("select idutente from $tablerelutenti where idnazione = '$num_nazione'");
if (!numlin_query($nazione_usata)) esegui_query("delete from $tablenazioni where idnazioni = '$num_nazione' ");
} # fine function cancella_nazione


function aggiorna_nazioni ($aggiungi_nazione,$nazioni_predefinite,$elimina_tutte_nazioni,$importa_nazioni,$id_utente,$id_utente_mod,$nuova_nazione,$utente_importa_nazioni,$pag,$tablenazioni,$tablerelutenti) {
if ($id_utente != 1 or $id_utente_mod == $utente_importa_nazioni) $importa_nazioni = "";
if ($aggiungi_nazione or $nazioni_predefinite or $elimina_tutte_nazioni or $importa_nazioni) {
if (get_magic_quotes_gpc()) $nuova_nazione = stripslashes($nuova_nazione);
$nuova_nazione = htmlspecialchars($nuova_nazione);
if (!$aggiungi_nazione or str_replace(" ","",$nuova_nazione)) {
$tabelle_lock = array("$tablenazioni","$tablerelutenti");
$tabelle_lock = lock_tabelle($tabelle_lock);
unset($lista_nazioni);
if ($aggiungi_nazione) $lista_nazioni[0] = $nuova_nazione;
else {
$naz_canc = esegui_query("select idnazione from $tablerelutenti where idutente = '$id_utente_mod' and idnazione is not NULL ");
$num_naz_canc = numlin_query($naz_canc);
for ($num1 = 0 ; $num1 < $num_naz_canc ; $num1++) cancella_nazione(risul_query($naz_canc,$num1,idnazione),$id_utente_mod,$tablenazioni,$tablerelutenti);
if ($nazioni_predefinite) {
include("./dati/lingua.php");
if ($lingua[$id_utente_mod] == "ita") include("./includes/lista_nazioni.php");
else if (@is_file("./includes/lang/".$lingua[$id_utente_mod]."/lista_nazioni.php")) include("./includes/lang/".$lingua[$id_utente_mod]."/lista_nazioni.php");
$num_nazioni = count($lista_nazioni);
for ($num1 = 0 ; $num1 < $num_nazioni ; $num1++) $lista_nazioni[$num1] = htmlspecialchars($lista_nazioni[$num1]);
} # fine if ($nazioni_predefinite)
else if ($importa_nazioni) {
$utente_importa_nazioni = aggslashdb($utente_importa_nazioni);
$naz_ut_imp = esegui_query("select distinct $tablenazioni.nome_nazione from $tablerelutenti inner join $tablenazioni on $tablerelutenti.idnazione = $tablenazioni.idnazioni where $tablerelutenti.idutente = '$utente_importa_nazioni' order by $tablenazioni.nome_nazione");
$num_naz_ut_imp = numlin_query($naz_ut_imp);
for ($num1 = 0 ; $num1 < $num_naz_ut_imp ; $num1++) {
$nazione = risul_query($naz_ut_imp,$num1,nome_nazione,$tablenazioni);
$lista_nazioni[$num1] = $nazione;
} # fine for $num1
} # fine if ($importa_nazioni)
} # fine else if ($aggiungi_nazione)
$num_nazioni_agg = count($lista_nazioni);
for ($num1 = 0 ; $num1 < $num_nazioni_agg ; $num1++) {
$nazione_esistente = esegui_query("select * from $tablenazioni where nome_nazione = '".aggslashdb($lista_nazioni[$num1])."' ");
if (numlin_query($nazione_esistente) == 0) {
$num_nazione = esegui_query("select max(idnazioni) from $tablenazioni ");
$num_nazione = risul_query($num_nazione,0,0) + 1;
esegui_query("insert into $tablenazioni (idnazioni,nome_nazione) values ('$num_nazione','".aggslashdb($lista_nazioni[$num1])."') ");
} # fine if (numlin_query($nazione_esistente) == 0)
else $num_nazione = risul_query($nazione_esistente,0,idnazioni);
$rel_esistente = esegui_query("select idnazione from $tablerelutenti where idutente = '$id_utente_mod' and idnazione = '$num_nazione' ");
if (!numlin_query($rel_esistente)) esegui_query("insert into $tablerelutenti (idutente,idnazione) values ('$id_utente_mod','$num_nazione') ");
} # fine for $num1
unlock_tabelle($tabelle_lock);
if ($aggiungi_nazione and $pag) echo mex("Nuova nazione aggiunta",$pag).".<br>";
} # fine if (!$aggiungi_nazione or str_replace(" ","",$nuova_nazione))
if ($nazioni_predefinite and $pag) echo mex("Nazioni predefinite ripristinate",$pag).".<br>";
if ($elimina_tutte_nazioni and $pag) echo mex("Nazioni cancellate",$pag).".<br>";
if ($importa_nazioni and $pag) echo mex("Nazioni importate",$pag).".<br>";
} # fine if ($aggiungi_nazione or $nazioni_predefinite or...
} # fine function aggiorna_nazioni


function cancella_regione ($num_regione,$id_utente_mod,$tableregioni,$tablerelutenti) {
esegui_query("delete from $tablerelutenti where idutente = '$id_utente_mod' and idregione = '$num_regione'");
$regione_usata = esegui_query("select idutente from $tablerelutenti where idregione = '$num_regione'");
if (!numlin_query($regione_usata)) esegui_query("delete from $tableregioni where idregioni = '$num_regione' ");
} # fine function cancella_regione


function aggiorna_regioni ($aggiungi_regione,$regioni_predefinite,$elimina_tutte_regioni,$importa_regioni,$id_utente,$id_utente_mod,$nuova_regione,$utente_importa_regioni,$pag,$tableregioni,$tablerelutenti) {
if ($id_utente != 1 or $id_utente_mod == $utente_importa_regioni) $importa_regioni = "";
if ($aggiungi_regione or $regioni_predefinite or $elimina_tutte_regioni or $importa_regioni) {
if (get_magic_quotes_gpc()) $nuova_regione = stripslashes($nuova_regione);
$nuova_regione = htmlspecialchars($nuova_regione);
if (!$aggiungi_regione or str_replace(" ","",$nuova_regione)) {
$tabelle_lock = array("$tableregioni","$tablerelutenti");
$tabelle_lock = lock_tabelle($tabelle_lock);
unset($lista_regioni);
if ($aggiungi_regione) $lista_regioni[0] = $nuova_regione;
else {
$naz_canc = esegui_query("select idregione from $tablerelutenti where idutente = '$id_utente_mod' and idregione is not NULL ");
$num_naz_canc = numlin_query($naz_canc);
for ($num1 = 0 ; $num1 < $num_naz_canc ; $num1++) cancella_regione(risul_query($naz_canc,$num1,idregione),$id_utente_mod,$tableregioni,$tablerelutenti);
if ($regioni_predefinite) {
include("./dati/lingua.php");
if ($lingua[$id_utente_mod] == "ita") include("./includes/lista_regioni.php");
else if (@is_file("./includes/lang/".$lingua[$id_utente_mod]."/lista_regioni.php")) include("./includes/lang/".$lingua[$id_utente_mod]."/lista_regioni.php");
$num_regioni = count($lista_regioni);
for ($num1 = 0 ; $num1 < $num_regioni ; $num1++) $lista_regioni[$num1] = htmlspecialchars($lista_regioni[$num1]);
} # fine if ($regioni_predefinite)
else if ($importa_regioni) {
$utente_importa_regioni = aggslashdb($utente_importa_regioni);
$naz_ut_imp = esegui_query("select distinct $tableregioni.nome_regione from $tablerelutenti inner join $tableregioni on $tablerelutenti.idregione = $tableregioni.idregioni where $tablerelutenti.idutente = '$utente_importa_regioni' order by $tableregioni.nome_regione");
$num_naz_ut_imp = numlin_query($naz_ut_imp);
for ($num1 = 0 ; $num1 < $num_naz_ut_imp ; $num1++) {
$regione = risul_query($naz_ut_imp,$num1,nome_regione,$tableregioni);
$lista_regioni[$num1] = $regione;
} # fine for $num1
} # fine if ($importa_regioni)
} # fine else if ($aggiungi_regione)
$num_regioni_agg = count($lista_regioni);
for ($num1 = 0 ; $num1 < $num_regioni_agg ; $num1++) {
$regione_esistente = esegui_query("select * from $tableregioni where nome_regione = '".aggslashdb($lista_regioni[$num1])."' ");
if (numlin_query($regione_esistente) == 0) {
$num_regione = esegui_query("select max(idregioni) from $tableregioni ");
$num_regione = risul_query($num_regione,0,0) + 1;
esegui_query("insert into $tableregioni (idregioni,nome_regione) values ('$num_regione','".aggslashdb($lista_regioni[$num1])."') ");
} # fine if (numlin_query($regione_esistente) == 0)
else $num_regione = risul_query($regione_esistente,0,idregioni);
$rel_esistente = esegui_query("select idregione from $tablerelutenti where idutente = '$id_utente_mod' and idregione = '$num_regione' ");
if (!numlin_query($rel_esistente)) esegui_query("insert into $tablerelutenti (idutente,idregione) values ('$id_utente_mod','$num_regione') ");
} # fine for $num1
unlock_tabelle($tabelle_lock);
if ($aggiungi_regione and $pag) echo mex("Nuova regione/provincia aggiunta",$pag).".<br>";
} # fine if (!$aggiungi_regione or str_replace(" ","",$nuova_regione))
if ($regioni_predefinite and $pag) echo mex("Regioni/provincie predefinite ripristinate",$pag).".<br>";
if ($elimina_tutte_regioni and $pag) echo mex("Regioni/provincie cancellate",$pag).".<br>";
if ($importa_regioni and $pag) echo mex("Regioni/provincie importate",$pag).".<br>";
} # fine if ($aggiungi_regione or $regioni_predefinite or...
} # fine function aggiorna_regioni



function cancella_parentela ($num_parentela,$id_utente_mod,$tableparentele,$tablerelutenti) {
esegui_query("delete from $tablerelutenti where idutente = '$id_utente_mod' and idparentela = '$num_parentela'");
$parentela_usata = esegui_query("select idutente from $tablerelutenti where idparentela = '$num_parentela'");
if (!numlin_query($parentela_usata)) esegui_query("delete from $tableparentele where idparentele = '$num_parentela' ");
} # fine function cancella_parentela



function aggiorna_parentele ($aggiungi_parentela,$parentele_predefinite,$elimina_tutte_parentele,$importa_parentele,$id_utente,$id_utente_mod,$nuova_parentela,$utente_importa_parentele,$pag,$tableparentele,$tablerelutenti) {
if ($id_utente != 1 or $id_utente_mod == $utente_importa_parentele) $importa_parentele = "";
if ($aggiungi_parentela or $parentele_predefinite or $elimina_tutte_parentele or $importa_parentele) {
if (get_magic_quotes_gpc()) $nuova_parentela = stripslashes($nuova_parentela);
$nuova_parentela = htmlspecialchars($nuova_parentela);
if (!$aggiungi_parentela or str_replace(" ","",$nuova_parentela)) {
$tabelle_lock = array("$tableparentele","$tablerelutenti");
$tabelle_lock = lock_tabelle($tabelle_lock);
unset($lista_parentele);
if ($aggiungi_parentela) $lista_parentele[0] = $nuova_parentela;
else {
$naz_canc = esegui_query("select idparentela from $tablerelutenti where idutente = '$id_utente_mod' and idparentela is not NULL ");
$num_naz_canc = numlin_query($naz_canc);
for ($num1 = 0 ; $num1 < $num_naz_canc ; $num1++) cancella_parentela(risul_query($naz_canc,$num1,idparentela),$id_utente_mod,$tableparentele,$tablerelutenti);
if ($parentele_predefinite) {
include("./dati/lingua.php");
if ($lingua[$id_utente_mod] == "ita") include("./includes/lista_parentele.php");
else if (@is_file("./includes/lang/".$lingua[$id_utente_mod]."/lista_parentele.php")) include("./includes/lang/".$lingua[$id_utente_mod]."/lista_parentele.php");
$num_parentele = count($lista_parentele);
for ($num1 = 0 ; $num1 < $num_parentele ; $num1++) $lista_parentele[$num1] = htmlspecialchars($lista_parentele[$num1]);
} # fine if ($parentele_predefinite)
else if ($importa_parentele) {
$utente_importa_parentele = aggslashdb($utente_importa_parentele);
$naz_ut_imp = esegui_query("select distinct $tableparentele.nome_parentela from $tablerelutenti inner join $tableparentele on $tablerelutenti.idparentela = $tableparentele.idparentele where $tablerelutenti.idutente = '$utente_importa_parentele' order by $tableparentele.nome_parentela");
$num_naz_ut_imp = numlin_query($naz_ut_imp);
for ($num1 = 0 ; $num1 < $num_naz_ut_imp ; $num1++) {
$parentela = risul_query($naz_ut_imp,$num1,nome_parentela,$tableparentele);
$lista_parentele[$num1] = $parentela;
} # fine for $num1
} # fine if ($importa_parentele)
} # fine else if ($aggiungi_parentela)
$num_parentele_agg = count($lista_parentele);
for ($num1 = 0 ; $num1 < $num_parentele_agg ; $num1++) {
$parentela_esistente = esegui_query("select * from $tableparentele where nome_parentela = '".aggslashdb($lista_parentele[$num1])."' ");
if (numlin_query($parentela_esistente) == 0) {
$num_parentela = esegui_query("select max(idparentele) from $tableparentele ");
$num_parentela = risul_query($num_parentela,0,0) + 1;
esegui_query("insert into $tableparentele (idparentele,nome_parentela) values ('$num_parentela','".aggslashdb($lista_parentele[$num1])."') ");
} # fine if (numlin_query($parentela_esistente) == 0)
else $num_parentela = risul_query($parentela_esistente,0,idparentele);
$rel_esistente = esegui_query("select idparentela from $tablerelutenti where idutente = '$id_utente_mod' and idparentela = '$num_parentela' ");
if (!numlin_query($rel_esistente)) esegui_query("insert into $tablerelutenti (idutente,idparentela) values ('$id_utente_mod','$num_parentela') ");
} # fine for $num1
unlock_tabelle($tabelle_lock);
if ($aggiungi_parentela and $pag) echo mex("Nuova parentela aggiunta",$pag).".<br>";
} # fine if (!$aggiungi_parentela or str_replace(" ","",$nuova_parentela))
if ($parentele_predefinite and $pag) echo mex("Parentele predefinite ripristinate",$pag).".<br>";
if ($elimina_tutte_parentele and $pag) echo mex("Parentele cancellate",$pag).".<br>";
if ($importa_parentele and $pag) echo mex("Parentele importate",$pag).".<br>";
} # fine if ($aggiungi_parentela or $parentele_predefinite or...
} # fine function aggiorna_parentele


?>